#include "gaim-assistant.h"
#include "gaim-assistant-ui.h"
#include "gaim-assistant-util.h"

 GtkWidget *
get_config_frame(GaimPlugin *plugin)
{

  // This is the configuration panel for this
  // beast.  It's pretty ugly and will change
  // a lot in the coming versions so, I'm not 
  // going to bother commenting this yet. :-)
  gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "In get_config_frame\n");
  
	GtkWidget *ret = NULL, *frame = NULL;
	GtkWidget *vbox = NULL, *hbox = NULL;
	GtkWidget *toggle = NULL, *entry = NULL;
	GtkWidget *toggle2 = NULL, *frame2 = NULL;
	GtkWidget *vbox2 = NULL;//, *hbox2 = NULL;
  GtkWidget *combo = NULL; //*label = NULL;
	ret = gtk_vbox_new(FALSE, 18);
	gtk_container_set_border_width(GTK_CONTAINER (ret), 12);

	// "Message Forwarding" 
	frame = gaim_gtk_make_frame(ret, _("Message Forwarding"));
	vbox = gtk_vbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(frame), vbox);

	/*--- Forward From Screen Name ---*/
	hbox = gtk_hbox_new(FALSE, 18);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
	GList *gaim_accounts = NULL;
	GList *accounts = NULL;
	GaimAccount *account = NULL;
	accounts = g_list_append(accounts, "<Dynamic Origin>");
	accounts = g_list_append(accounts, "NULL");
	for(gaim_accounts = gaim_accounts_get_all(); gaim_accounts != NULL;
		 gaim_accounts = gaim_accounts->next) {
		 	account = (GaimAccount *)gaim_accounts->data;
	 			gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "Adding %s \n", account->username);
		 	accounts = g_list_append(accounts, account->username);
		 	accounts = g_list_append(accounts, account->username);
	 }

	combo = gaim_gtk_prefs_dropdown_from_list(vbox, "_Origin Account: ",
			GAIM_PREF_STRING,"/plugins/gtk/X11/gassist/origin_account",
			accounts);
			

	/*--- For Message forwarding ---*/
	hbox = gtk_hbox_new(FALSE, 18);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
	toggle=gaim_gtk_prefs_checkbox("Forward _IM's To: ",
		"/plugins/gtk/X11/gassist/forward_msgs", hbox);
	fwd_toggle_hndl=toggle;
		
	/*--- Screen name to forward to ---*/
	entry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
	gtk_entry_set_max_length(GTK_ENTRY(entry), 256);
	gtk_widget_set_sensitive(GTK_WIDGET(entry),
	                         gaim_prefs_get_bool("/plugins/gtk/X11/gassist/forward_msgs"));
	gtk_entry_set_text(GTK_ENTRY(entry),
	                   gaim_prefs_get_string("/plugins/gtk/X11/gassist/fwd_scrnm"));
	g_object_set_data(G_OBJECT(toggle), "fwd_scrnm", entry);
	g_signal_connect(G_OBJECT(toggle), "toggled",
	                 G_CALLBACK(fwdmsgs_toggle_cb), "forward_msgs");
	g_signal_connect(G_OBJECT(entry), "focus-out-event",
	                 G_CALLBACK(options_entry_cb), "fwd_scrnm");

  hbox = gtk_hbox_new(FALSE, 18);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  toggle=gaim_gtk_prefs_checkbox("Forward _Auto Reply", "/plugins/gtk/X11/gassist/auto_reply", hbox);
  
  
	/* --- To disable the online check of the forward to screen name ---
	 * --- Used for people forwarding to cell phones. (See tracker 	 ---
	 * --- item 1092480 on sf.net for more info.					 --- */

	hbox = gtk_hbox_new(FALSE, 18);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
	toggle = gaim_gtk_prefs_checkbox("E_nable Forward To Account Online Check", 
		"/plugins/gtk/X11/gassist/online_check", hbox);

	/* --- For Queing Messages through gaim-assistant ---*/
	/*hbox = gtk_hbox_new(FALSE, 18);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
	toggle2 = gaim_gtk_prefs_checkbox("_Que Messages if screen name to forward to is offline",
		"/plugins/gtk/X11/gassist/que_fwd_msgs", hbox);
	*/
	gtk_widget_set_sensitive(GTK_WIDGET(toggle2),
		gaim_prefs_get_bool("/plugins/gtk/X11/gassist/online_check"));
	/*g_object_set_data(G_OBJECT(toggle), "online_chk", toggle2);
	g_signal_connect(G_OBJECT(toggle), "toggled",
	                 G_CALLBACK(online_chk_toggle_cb), "");
*/
	// --- For auto response throttling. --- 
	/*hbox = gtk_hbox_new(FALSE, 18);
  	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);

	label = gtk_label_new_with_mnemonic("_Timeout between sending auto-responses (in seconds)");
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
	entry = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
	gtk_entry_set_max_length(GTK_ENTRY(entry), 5);
	gtk_entry_set_width_chars(GTK_ENTRY(entry), 5);
	gtk_entry_set_text(GTK_ENTRY(entry), 
    gaim_prefs_get_string("/plugins/gtk/X11/gassist/auto_resend_timeout"));
	gtk_label_set_mnemonic_widget(GTK_LABEL(label), entry);
	g_signal_connect(G_OBJECT(entry), "focus-out-event", 
	G_CALLBACK(options_art_cb), "auto_resend_timeout");
*/

  
	frame2 = gaim_gtk_make_frame(ret, _("Forwarding Security"));
	vbox2 = gtk_vbox_new(FALSE, 5);
	gtk_container_add(GTK_CONTAINER(frame2), vbox2);

	/*--- Forward Only for buddies on my buddy list ---*/
	hbox = gtk_hbox_new(FALSE, 18);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 0);
	gaim_gtk_prefs_checkbox("Forward Only for buddies on my buddy _list.",
		"/plugins/gtk/X11/gassist/blist_only", hbox);

	/*--- Show screen name messages are forwared to ---*/
	hbox = gtk_hbox_new(FALSE, 18);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 0);
	toggle = gaim_gtk_prefs_checkbox("_Show screen name for forwarded messages\n to original sender.",
		"/plugins/gtk/X11/gassist/show_fwdscrnm", hbox);
	g_signal_connect(G_OBJECT(toggle), "toggled", 
		G_CALLBACK(shwscn_toggle_cb), "show_fwdscrnm");
		
		
	/*--- Show screen name messages are forwared to only for those on the buddy list ---*/
	hbox = gtk_hbox_new(FALSE, 18);
	gtk_box_pack_start(GTK_BOX(vbox2), hbox, FALSE, FALSE, 0);
	toggle2 = gaim_gtk_prefs_checkbox("_Only Show screen name for forwarded messages\n if sender is on the buddy list.",
		"/plugins/gtk/X11/gassist/show_fwdscrnm_blist_only", hbox);
		
	gtk_widget_set_sensitive(GTK_WIDGET(toggle2),
		gaim_prefs_get_bool("/plugins/gtk/X11/gassist/show_fwdscrnm"));

	g_object_set_data(G_OBJECT(toggle), "show_fwdscrnm_blist_only", toggle2);

  
	gtk_widget_show_all(ret);
	return ret;
}


/**************** CALL BACKS *******************/
void online_chk_toggle_cb(GtkWidget *widget, gpointer data)
{

	// specifically for saving the forward_msgs field 
	// cuz it activates or deactivates the gtk_entry widget
	// for fwd_scrname
	gboolean on = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
	GtkWidget *toggle2 = g_object_get_data(G_OBJECT(widget), "online_chk");
	gtk_widget_set_sensitive(toggle2, on);

}

 void
fwdmsgs_toggle_cb(GtkWidget *widget, gpointer data)
{

	// specifically for saving the forward_msgs field 
	// cuz it activates or deactivates the gtk_entry widget
	// for fwd_scrname
	gboolean on = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
	GtkWidget *entry = g_object_get_data(G_OBJECT(widget), "fwd_scrnm");
	gtk_widget_set_sensitive(entry, on);
	GaimPluginAction *action=NULL;
	setting_from_toggle=1;
	toggle_forwarding(action);

}

void shwscn_toggle_cb(GtkWidget *widget, gpointer data){


	// specifically for saving the forward_msgs field 
	// cuz it activates or deactivates the gtk_entry widget
	// for fwd_scrname
	gboolean on = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
	GtkWidget *toggle = g_object_get_data(G_OBJECT(widget), "show_fwdscrnm_blist_only");
	gtk_widget_set_sensitive(toggle, on);

}

void err_win_cb(GtkWidget* widget, gpointer gwin){

  // call back for the error window.
  if(GTK_IS_WIDGET((GtkWidget *)gwin))
  	gtk_widget_destroy((GtkWidget *)gwin);

}
 gboolean
options_art_cb(GtkWidget *widget, GdkEventFocus *evt, gpointer data)
{
	if (data == NULL)
		return FALSE;

  // attempt to validate the string.
  // mmmm.... string parsing ugliness....
  int tmp_value = 0;
  
  char tmp_string[5];
  tmp_string[0]='\0';
  strcpy(tmp_string, gtk_entry_get_text(GTK_ENTRY(widget)));
  if(tmp_string[0]=='\0'){
	tmp_value=0;
  }
  else{
	
  	char *tmp_endptr= (char *)malloc(sizeof(char)*6);
  	gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "In options_art_cb with value %s\n", tmp_string);
    //tmp_endptr[0]='\0';
  	gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "In options_art_cb with value %s\n", tmp_string);
  	tmp_value = strtol(tmp_string, &tmp_endptr, 0);
  	gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "In options_art_cb with value %s\n", tmp_string);
	  if(tmp_endptr[0]!='\0'){
	  // display an error to the user.
    

		  GtkWidget *win;
	
		  GtkWidget *vbox, *hbox;
		  GtkWidget *button;
		  GtkWidget *label;
		  char strbuf[BUF_LONG];
    	// Set up the window, title, call back 
    	// and make it modal so nothing else
    	// can happen while it's displayed.
    	// *maniacal laughter*
      
      GAIM_DIALOG(win);
			
		  gtk_window_set_title(GTK_WINDOW(win), "Error");
      gtk_window_set_resizable(GTK_WINDOW(win), FALSE);
      gtk_window_set_modal(GTK_WINDOW(win), TRUE);
      g_signal_connect(G_OBJECT(win), "destroy",
        GTK_SIGNAL_FUNC(err_win_cb), NULL);



      
      // WINDOW CONTENTS
	  	vbox = gtk_vbox_new(0,2);
		  gtk_container_set_border_width(GTK_CONTAINER(vbox),4);
  		gtk_container_add(GTK_CONTAINER(win), vbox);
	    gtk_widget_show (vbox);
  		g_snprintf(strbuf, sizeof(strbuf), "Auto Response Timeout MUST be a number only!");
	  	label = gtk_label_new(strbuf);
		  gtk_box_pack_start(GTK_BOX(vbox), label, 0, 0, 0);
  		gtk_widget_show(label);
     

	  	hbox = gtk_hbox_new(FALSE, 2);
		  gtk_box_pack_end(GTK_BOX(vbox), hbox, 0, 0, 0);
  		gtk_widget_show(hbox);
		

	  	button = gtk_button_new_with_label("Ok");
		  g_signal_connect(GTK_OBJECT(button), "clicked",
			  GTK_SIGNAL_FUNC(err_win_cb),
			  (gpointer)win);
      gtk_box_pack_end(GTK_BOX(hbox), button, 0, 0, 0);
      gtk_widget_set_size_request(button, 100, -1);
		  gtk_widget_show(button);
	
  		gtk_widget_show(win);


      //g_free(tmp_endptr);
      return FALSE;
     
    }

    //g_free(tmp_endptr);
  }
  // if we get here, no match is found. so save that shit :-)
	gchar pref[256];

	g_snprintf(pref, sizeof(pref), "/plugins/gtk/X11/gassist/%s", (char *) data);

	gaim_prefs_set_string(pref, gtk_entry_get_text(GTK_ENTRY(widget)));


  return FALSE;



}

gboolean options_entry_cb(GtkWidget *widget, GdkEventFocus *evt, gpointer data)
{

  // call back for the gtk entry field for fwd_scrnm
  // does specific processing of the field to make 
  // sure certain conditions are not met.
	if (data == NULL)
		return FALSE;


  // ok here we walk the accounts in GAIM 
  // to make sure the screen name they spec'ed
  // is NOT in the accounts list.  Bad things could
  // happen if it is and is signed on.
	GList *accounts = gaim_accounts_get_all();
	GaimAccount *tmp_acct = (GaimAccount *)accounts->data;

	while(tmp_acct!=NULL){
		

		char tmp_username[256];
		char tmp_screenname[256];
	
		strcpy(tmp_username, tmp_acct->username);
		strcpy(tmp_screenname, gtk_entry_get_text(GTK_ENTRY(widget))); 

    // despace the 2 strings, easier to compare them when 
    // they don't have odd white spaces in them. :-)
		despace_string(tmp_username, strlen(tmp_username));
		despace_string(tmp_screenname, strlen(tmp_screenname));	

    
    if(!g_ascii_strcasecmp(tmp_username, tmp_screenname)){

      // ok so the screen name the user entered exists in
      // GAIM's config, *tsk tsk* Nope, can't allow that.
      // set up the error window and let it do it's thing
      // then exit without saving the changes.
			GtkWidget *win;

			GtkWidget *vbox, *hbox;
			GtkWidget *button;
			GtkWidget *label;
			char strbuf[BUF_LONG];
      // Set up the window, title, call back 
      // and make it modal so nothing else
      // can happen while it's displayed.
      // *maniacal laughter*
      GAIM_DIALOG(win);
			
			gtk_window_set_title(GTK_WINDOW(win), "Error");
      gtk_window_set_resizable(GTK_WINDOW(win), FALSE);
      gtk_window_set_modal(GTK_WINDOW(win), TRUE);
      g_signal_connect(G_OBJECT(win), "destroy",
        GTK_SIGNAL_FUNC(err_win_cb), NULL);



      
      // WINDOW CONTENTS
			vbox = gtk_vbox_new(0,2);
			gtk_container_set_border_width(GTK_CONTAINER(vbox),4);
			gtk_container_add(GTK_CONTAINER(win), vbox);
			gtk_widget_show (vbox);

			g_snprintf(strbuf, sizeof(strbuf), "Screen Name %s cannot exist in GAIM account list.", tmp_username);
			label = gtk_label_new(strbuf);
			gtk_box_pack_start(GTK_BOX(vbox), label, 0, 0, 0);
      gtk_widget_show(label);
      

			hbox = gtk_hbox_new(FALSE, 2);
			gtk_box_pack_end(GTK_BOX(vbox), hbox, 0, 0, 0);
			gtk_widget_show(hbox);
			

			button = gtk_button_new_with_label("Ok");
			g_signal_connect(GTK_OBJECT(button), "clicked",
				GTK_SIGNAL_FUNC(err_win_cb),
				(gpointer)win);
      gtk_box_pack_end(GTK_BOX(hbox), button, 0, 0, 0);
      gtk_widget_set_size_request(button, 100, -1);
			gtk_widget_show(button);
	
			gtk_widget_show(win);
			return FALSE;
		}

    // nope didn't find a match yet, so keep walking
		accounts = g_list_next(accounts);
		if(accounts==NULL){
			tmp_acct = NULL;
		}
		else{
			tmp_acct = (GaimAccount *) accounts->data;
		}

	}

  // if we get here, no match is found. so save that shit :-)
	gchar pref[256];

	g_snprintf(pref, sizeof(pref), "/plugins/gtk/X11/gassist/%s", (char *) data);

	gaim_prefs_set_string(pref, gtk_entry_get_text(GTK_ENTRY(widget)));

	return FALSE;
}
