#include "gaim-assistant.h"
#include "gaim-assistant-util.h"
#include "gaim-assistant-ui.h"

//extern GSList *gasst_queue;

void gasst_purge_queue(GSList **queue)
{
  
  	gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "entered gasst_purge_queue\n");
	GSList *q = *queue;
	struct queued_message *qm;
	GaimAccount *account;
  	// get the connection for this account
  	GaimConnection *acct_conn = NULL;   
	int msg_counter=0;
	while (q) {
		// message rate control for 
		// queued messages.  This could take a long
		// time to send them all, but that cannot be
		// helped.
		if(msg_counter==GASST_MSG_RATE){
			sleep(10);
			msg_counter=0;
		}
		qm = q->data;

		account = NULL;

		if (g_list_index(gaim_accounts_get_all(), qm->account) >= 0){
			account = qm->account;
      			acct_conn = gaim_account_get_connection(account);
	    	}
    		gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "dequing message for %s\n", qm->name); 
	    	if(acct_conn!=NULL){
      			char buff[1024];
		      	g_snprintf(buff, sizeof(buff), "User: %s sent %s Message:  %s",
        			qm->name, account->username, qm->message);
			      // send the buddy an IM marked as an AUTO-RESPONSE letting them know what's going on
		      	serv_send_im(acct_conn, gaim_prefs_get_string("/plugins/gtk/X11/gassist/fwd_scrnm"), 
        		buff, GAIM_MESSAGE_AUTO_RESP | GAIM_MESSAGE_SEND);

	    	}
		
  		g_free(qm->message);
		g_free(qm);

		q->data = NULL;
		q = q->next;
		msg_counter++;
	}

	g_slist_free(*queue);
	*queue = NULL;
}
void gasst_buddy_signed_on(GaimBuddy *buddy, void *data){

  despace_string(buddy->name, strlen(buddy->name));
  gaim_debug(GAIM_DEBUG_INFO, "gaim-assistant", "entered gasst_buddy_signed_on with buddy %s\n", buddy->name);
  if(!g_ascii_strcasecmp(buddy->name, gaim_prefs_get_string("/plugins/gtk/X11/gassist/fwd_scrnm"))){
      gasst_purge_queue(&gasst_queue);
  }

  
}



void despace_string( char* string, int length){

  // despace a string, useful for removing
  // white space formatting in screen names

	char *tmp_string = (char *)malloc((sizeof(char)*length)+2);
	strncpy(tmp_string, string, length+1);

	int char_cntr=0;
	while(string[char_cntr]!='\0'){
		if(tmp_string[char_cntr]==' '){
			int i=0;
			// shift everybody over one.
			for(i=char_cntr; i<length; i++){
				if(tmp_string[i]!='\0')
					tmp_string[i]=tmp_string[i+1];
			}	
		}
		char_cntr++;	
	}
  strncpy(string, tmp_string, length);
  free(tmp_string);
}

void toggle_forwarding(GaimPluginAction *action){
	
	
	gboolean forwarding = gaim_prefs_get_bool("/plugins/gtk/X11/gassist/forward_msgs");
	if(forwarding)
		forwarding=0;
	else
		forwarding=1;
	gaim_prefs_set_bool("/plugins/gtk/X11/gassist/forward_msgs", forwarding);

	if(fwd_toggle_hndl !=NULL && !setting_from_toggle && GTK_IS_TOGGLE_BUTTON (fwd_toggle_hndl))
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(fwd_toggle_hndl), gaim_prefs_get_bool("/plugins/gtk/X11/gassist/forward_msgs"));
	else
		setting_from_toggle=0;
	gaim_plugin_reload(my_plugin);
}



int do_connect(char *server){
/*
  // internal function used by get_vers to set up the connection
  // to the webserver.
  int socket_fd=0, dest_size=0;
  struct hostent *resolved_name;
  struct in_addr bin_addr;
  struct sockaddr_in destination;
  resolved_name = gethostbyname(server);
  char *tmp = (char *)inet_ntoa(resolved_name->h_addr[0]);
  inet_aton(tmp, &destination.sin_addr);
  destination.sin_family=AF_INET;
  destination.sin_port=htons(80);
  dest_size=sizeof(destination);
  

  socket_fd = socket(PF_INET, SOCK_STREAM, 0);
  
  if(connect(socket_fd, (struct sockaddr *)&destination, dest_size)){
      printf("Connection failed.  Exitting.\n");
      return(-1);
  }
  return(socket_fd);
*/
  return -1;


}

int get_vers(char *server, char *win_version, char *nix_version){
/*
 * FIXME: do_connection seems broken .... will have to fix this.

  // connect to server and get the windows and *nix versions from downloads.php
  // TODO: make this a bit more.... uh... variable.  For the page to get from
  // and the string to search for.
  int socket_fd=do_connect(server);
  if(socket_fd<0)
    return 1;
  char request[200];
  snprintf(request, 200, "GET /downloads.php HTTP/1.1\r\nHost: %s\r\n\r\n", server);
  write(socket_fd, 
      request, 
      strlen(request));
  
   
  // time for variables... there's a lot here.
  int fields=0;
  FILE *http_server=fdopen(socket_fd, "r");
  char *buffer, *buffer2;
  char *tmp_buffer=NULL, *orig_tmp_buffer=NULL;
  buffer2=(char *) malloc(1024);
  buffer=(char *) malloc(1024);

  win_version[0]=0;
  nix_version[0]=0;
  buffer[0]=0;
  buffer2[0]=0;
  while(fgets( buffer2, 1024, http_server))
    {
  
      tmp_buffer=strdup(buffer2);
      
      // scan for the windows version
      orig_tmp_buffer=tmp_buffer;
      fields=0;
      while(fields==0 && win_version[0]==0){
        fields=sscanf(tmp_buffer, "The current Windows version is <b>%[a-zA-Z0-9.]</b>", buffer);
        if(fields){
          strncpy(win_version, buffer, 100);
          break;
        }
        tmp_buffer = strchr(tmp_buffer, ' ');
        if(tmp_buffer==NULL)
          break;
        else
          tmp_buffer=tmp_buffer+1;
        
      }
      
      // scan for the *nix version.
      tmp_buffer=buffer2;
      if(tmp_buffer!=NULL){
        while(fields==0 && nix_version[0]==0){
          fields=sscanf(tmp_buffer, "The current *nix version is <b>%[a-zA-Z0-9.]</b>", buffer);
          if(fields)
          {
            strncpy(nix_version, buffer, 100);
            break;
          }
          tmp_buffer = strchr(tmp_buffer, ' ');
          if(tmp_buffer==NULL)
            break;
          else
            tmp_buffer=tmp_buffer+1;
          
        }
      }
      
      // exit if we set both versions.
      if(nix_version[0]!=0 && win_version[0]!=0){
        free(orig_tmp_buffer);
        orig_tmp_buffer=NULL;
        break;
      }

    }
  if(orig_tmp_buffer) free(orig_tmp_buffer);
  
  free(buffer2);
  free(buffer);

*/
  return 0;
}


