;NSIS Modern User Interface
;Basic Example Script
;Written by Joost Verburg

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  ;Name and file
  Name "Gaim-Assistant"
  OutFile "gaim-assistant.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\gaim"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKLM "Software\gaim" ""

  var GAIM_VER

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "COPYING"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES

; *** CURRENTLY NOT USED  
  ;!insertmacro MUI_UNPAGE_CONFIRM
  ;!insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "Gaim Assistant" SecDummy

  
  SectionIn RO
  SetOutPath $INSTDIR
  IfFileExists $INSTDIR\gaim-assistant* exists
  
  install:
  File gaim-assistant.dll
  goto done
  

  exists:
    Delete $INSTDIR\gaim-assistant*
    IfErrors error_lbl
    goto install
  error_lbl:
    MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP "Unable to clean up previous install.  Please make sure you exit Gaim."
    Quit
  done:
SectionEnd

;--------------------------------
;Installer Functions

Function .onInit

  
  ; read in the Gaim version
  ReadRegStr $GAIM_VER HKLM Software\gaim "Version"
  StrCpy $R0 0
  StrCpy $R1 $GAIM_VER
  loop:
    StrCpy $R3 $R1 1 $R0
    StrCmp $R3 "." done
    IntOp $R0 $R0 + 1
    goto loop
  done:
  StrCpy $R4 $GAIM_VER $R0
  StrCmp $R4 "1" exit
  MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP "This version of Gaim Assistantn is meant for the 1.x.x version of Gaim. Your version seems to be $R4.x.x"
  Quit
  exit:

  StrCpy $INSTDIR "$INSTDIR\plugins"
  	
FunctionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecDummy ${LANG_ENGLISH} "The Gaim-Assistant Plugin."

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecDummy} $(DESC_SecDummy)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section
; **** CURRENTLY NOT USED *****
;Section "Uninstall"

  ;ADD YOUR OWN FILES HERE...

  ;Delete "$INSTDIR\gaim-assistant.dll"


;SectionEnd
